#!/usr/local/bin/perl
# Ce script ncessite perl 5.
# En cas d'erreur (et pour serveur Linux souvent),
# ressayez en changeant la premire ligne en: #!/usr/bin/perl

print ("Content-type: text/html\n\n");

# farfouineur.pl : script de recherche de document. (MOTEUR DE RECHERCHE INTERNE) #
# Dans votre rpertoire cgi-bin, tlchargez ce script en mode ASCII, chmod 755.  #
# Tlchargez aussi, la page farfouineur.html permettant de lancer une recherche, #
# dans un rpertoire o vous mettez vos pages HTML normales.                      #

# v2.02 01/10/1999
$version='2.02';
###################################################################################
# Ceci est un script CGI en Perl freeware, ralis par Sbastien Joncheray.       #
# Vous pouvez l'utiliser gratuitement,  la condition de ne                       #
# pas changer son contenu, notamment, les parties faisant mentions de l'auteur.   #
# De nombreux autres scripts perl en francais, sont disponibles gratuitement     #
# http://www.perl-gratuit.com                                                     #
# E-mail pour toute question, remarque : info@perl-gratuit.com                    #
# Contactez-moi pour tout tout autre script personnalis                          #
# permettant une relle interaction avec l'internaute.                            #
###################################################################################
# Tous droits de modification/distribution/vente rservs                         #
# Merci de me contacter dans ces cas l :-)                                       #
###################################################################################

##############################################################################
## Mthode de scoring de chaque page html :                                  #
## 1 point  chaque fois qu'un mot-cl est trouv dans la page html          #
## 4 point en +, pour chaque mot-cl trouv dans le titre de la page html    #
## 3 point en +, pour chaque mot-cl trouv dans la description de la page   #
## 2 point en +, pour chaque mot-cl trouv dans les META KEYWORD de la page #
##############################################################################

##################################################################################
# Configuration des Variables							 #
##################################################################################
# POUR DESACTIVER UNE LIGNE METTEZ UN DIESE (#) DEVANT, et vice-versa            #
##################################################################################
# Les dtections automatiques ci-dessous fonctionnent bien sur serveur Apache,   #
# et tous les autres aussi en principe,  moins que la configuration du serveur  #
# ou du site soit spciale (souci probable en cas de sous-hbergement par exemple#
# c'est  dire si votre site n'est pas accessible directement par le seul nom de #
# domaine : votre site=http://www.votre-domaine.com : OK                         #
#           votre site=http://www.hebergeur.com/votresite/ : Pas OK...  )        #
##################################################################################


# URL complte de ce script : #################################################
#  - Soit vous laissez faire la dtection automatique :                       #
     $cgiurl='http://'.$ENV{'SERVER_NAME'}.$ENV{'SCRIPT_NAME'};                
#  - Soit vous enlevez le dise (#) ci-dessous et modifiez la ligne:          #
#    $cgiurl='http://www.votre-site.com/cgi-bin/farfouineur.pl';              #
###############################################################################
# Indiquez ci-dessous le rpertoire de base des pages html de votre site ######   
# AVEC slash '/' final                                                   ######
#  - Soit vous laissez faire la dtection automatique :                       #
     $basedir=$ENV{'DOCUMENT_ROOT'};
#  - Soit vous enlevez le dise ci-dessous et modifier le chemin en relatif,  #
#    par rapport  l'emplacement de ce script :                               #
#    $basedir = '../../';                                                     #
#  - Soit Idem en absolu :                                                    #
#    $basedir = '/usr/www/monsiteweb/';                                       #
#                                                                             #
# Laissez la ligne ci-dessous qui vrifie que $basedir finit bien par un / :  #
if ($basedir!~ /\/$/) {$basedir.='/';}
###############################################################################
# Indiquez ci-dessous votre homepage AVEC un / final ##########################
#  - Soit vous laissez faire la dtection automatique :                       #
     $baseurl='http://'.$ENV{'SERVER_NAME'};
#  - Soit vous enlevez le # de la ligne ci-dessous, et la modifiant.          #
#    $baseurl = 'http://www.perl-gratuit.com/';                               #

# Laissez la ligne ci-dessous qui vrifie que $baseurl finit bien par un / :#
if ($baseurl!~ /\/$/) {$baseurl.='/';}
###############################################################################
# Indiquez ci-dessous, les extensions de fichier dans lesquel le script peut  #
# faire la recherche                                                          #
  @file_types=('.html','.htm','.shtml');
###############################################################################
# Indiquez ci-dessous la liste complte des rpertoires et sous-rpertoire    #
# dans laquelle le script peut faire la recherche.                            #
# Mettez les noms de rpertoires par rapport au rpertoire de base de vos     #
# pages html ($basedir).                                                      #
# Les noms de rpertoire ne doivent pas commencer par un slash /,mais doivent #
# finir par un slash /.                                                       #
# Ne mettez pas de noms de rpertoires qui n'existent pas !                   #

@dirs=(
       '/',
       'perl/',
       'perl/compteur-t1-ssi/'
       );
  # Attention, pas de virgule avant la dernire parenthse ci-dessus !       #
                                                                             #
# Done  FIN DE LA CONFIGURATION !!                                           #
##############################################################################







# Rcupration des donnes
if (!$ENV{'QUERY_STRING'}) {			# Aucun paramtre. Afficher le formulaire seulement
  &header;					# Affiche haut de page
  &formulaire;					# Affiche formulaire
  &footer;					# Affiche bas de page
  exit;						# Quitter !
}
%form=&receiveget;				# Rcupration des donnes du formulaire

if ($form{'command'} eq 'aide') {		# Afficher l'Aide
  &aide;					# Affiche l'Aide
  exit;						# Quitter !
}
$form{'terms'}=~ s/\+//g;			# limine les +
$form{'terms'}=~ s/\://g;			# limine les :
$form{'terms'}=~ s/\"//g;			# limine les "

@keyword= split(/\s+/, $form{'terms'});		# Tableau des mots-cls taps par le visiteur (sparation espace)
$nb_keyword=@keyword;				# Nombre de mots de recherche
%result=();					# Tableau des rsultats
%score=();					# Score de chaque fichier
%title=();					# Table de hachage des titres des fichiers
%description=();				# Table de hachage des description des fichiers
%date=();					# Table de hachage des date/heure de dernire modification des fichiers
%metakeyword=();				# Table de hachage des meta keywords des fichiers
%size=();					# Table de hachage des tailles des fichiers

# Chercher la liste des fichiers  explorer
@files=();					# Tableau liste des fichiers.
&files_list; 					# Rempli @files de la listes des fichiers  explorer.

# Farfouiner dans les fichiers
&search_and_save;

# On limine les fichiers ne comportant pas ce que l'on cherche
&eliminer;

$nb_fichier=@files;

# Mettre un Score  chaque fichier
&score;

# Tri par score dcroissant
&trier;

$max_score=$score{$files[0]};			# Le score maxi est celui du premier fichier aprs tri


# Page de rsultats
$fini=0;					# va se mettre  1 si tous les rsultats ont t affichs
&header;
&formulaire;
&affiche_resultat;

&liens_suite;
&footer;
1;

################################################
sub receiveget {
  local(%postdata)=();
  if ($ENV{'REQUEST_METHOD'} eq 'GET') {
    local ($data)='';                          # Chaine envoye
    $data=$ENV{'QUERY_STRING'};
    foreach $d (split('&',$data)) {            # sparation de la chaine par paires
      local ($nom,$valeur)=split('=',$d);      # paires spares
      $nom=&url_decode($nom);
      $valeur=&url_decode($valeur);
     $postdata{$nom}=$valeur;                  # paires ranges dans data
      }
    } else {
      print ("Content-type: text/html\n\n<H1>webmaster says : GET Error in CGI method <BR>GO BACK and TRY again</H1>Vous ne pouvez accder ici par ce moyen.");
      die ("webmaster says : GET Error in CGI method") ; 
    }
  return %postdata ;
}
################################################
sub url_decode {
  local ($s)=@_;
  $s=~ tr/+/ /;
  $s=~ s/%([0-9A-F][0-9A-F])/pack("C",oct("0x$1"))/ge;
  $s;
}
################################################
sub files_list {
local ($file)='';
local ($type)='';
local ($flag)=0;

  foreach $dir (@dirs) {	# on ouvre chaque rpertoire indiqu dans @dirs
    $dir=~ s/^\///;		# enlve le / ventuel de dbut de rpertoire
    opendir (MYDIR,"$basedir$dir") || (print "impossible de lire dans le rpertoire $basedir$dir :$!" and exit); 
    while ($newfile=readdir(MYDIR)) { # pour chaque fichier du rpertoire
      if ((!(-d "$basedir$dir$newfile")) && (-T "$basedir$dir$newfile")) { ## on s'assure que ce n'est pas un rpertoire, et que c'est un fichier texte
        $flag=0;
        foreach $type (@file_types) {
          if ($newfile=~ /$type$/) {
             $flag=1;				# c'est un fichier avec une extension valide
          }
        }
        if ($flag) {
          push (@files,"$dir$newfile");
        }
      }
    }
    closedir (MYDIR);
   }
}
################################################
################################################
sub search_and_save {
local ($fichier,$mot)=('','');
local ($contenu)='';
local (@lignes)=();
local ($nb,$i,$pp)=(0,0,0);

  foreach $fichier (@files) {
    open(FILE,"$basedir$fichier") || (print "Impossible ouvrir en lecture $basedir$fichier : $!" and exit);
    @lignes = <FILE>;
    close(FILE);

    $contenu = join(' ',@lignes);		# Les lignes sont mises bout  bout, spares par un espace
    @lignes=();					# On libre de l'espace mmoire.

    $size{$fichier}=int((length($contenu)+500)/1000);	# taille en octets du fichier, arrondie au plus prs.

    $contenu =~ s/\n//g;			# On enlve les retours  la ligne.
    $contenu =~ s/\r//g;			# Au cas o ...
    $contenu =~ s/\&eacute\;//g;		# Remplace les &eacute de la page html en 
    $contenu =~ s/\&egrave\;//g;		# Remplace les &egrave de la page html en 
    $contenu =~ s/\&agrave\;//g;		# Remplace les &agrave de la page html en 
    $contenu =~ s/\&ecirc\;//g;		# Remplace les &ecirc de la page html en 
    $contenu =~ s/\&ccedil\;//g;		# Remplace les &ccedil de la page html en 
    # on pourrait ajouter d'autres conversions des codes html (,, ...), mais cela alourdit le temps de traitement,
    # on se contente donc des plus courants.





    ##### CHERCHER LE TITRE ####
    if (($contenu=~ /<title>([^<]*)<\/title>/i) && (length($1)>0)) {
      $titre{$fichier}=$1;
    }else {
      $titre{$fichier}='? nbsp; ? &nbsp; ?';	# Titre de la page inconnu
    }
    ##### CHERCHER LA DESCRIPTION ####
    if (($contenu=~ /<meta[^\>]*name=\"description\"[^\>]*content=\"([^\"]*)\">/i) && (length($1)>0)) {
      $description{$fichier}=$1;
    }else {
      $description{$fichier}='';		# Pas de description
    }
    ##### CHERCHER LES META KEYWORD ####
    if (($contenu=~ /<meta[^\>]*name=\"keyword[^\"]*\"[^\>]*content=\"([^\"]*)\">/i) && (length($1)>0)) {
      $metakeyword{$fichier}=$1;
    }else {
      $metakeyword{$fichier}='';		# Pas de META KEYWORD
    }
    ##### CHERCHER LA DATE DE DERNIERE MODIFICATION ####
    $pp=-M "$basedir$fichier";			# Retourne le nb de jours depuis la dernire modif
    $pp=localtime(time()-$pp*86400);		# Transforme en date normale.
    $date{$fichier}=$pp;

    for ($i=0;$i<=$nb_keyword-1;$i++) {		# Pour chaque mot de recherche
      $contenu2=$contenu;			# On travaille sur une variable qui va avoir son contenu rogn
      $nb=0;					# On reset le nb d'occurences

      if ($form{'case'} eq 'Insensitive') { 	# Si peu importe les majuscules/minuscules.
        while ($contenu2=~ s/$keyword[$i]/ /i) {	# Chaque fois que l'on trouve le mot on le supprime, pour ne pas le compter 2 fois.
          $nb++; 
        }
      }else {
        while ($contenu2=~ s/$keyword[$i]/ /) {		# Idem, en tenant comptedes majuscules/minuscules
          $nb++; 
        }
      }
      $result{"$fichier.$i"}=$nb;			# On range le rsultat dans la variable %result()
    }
  }
}
################################################
################################################
sub eliminer {
local ($i)=0;
local ($fichier)='';
local (@files2)=();
local ($flag)=0;

  # D'abord on limine les noms de fichiers qui n'ont pas de mots-cl recherchs

  foreach $fichier (@files) {			# Pour chaque fichier.
    if ($form{'boolean'} eq 'OR') {		# Il suffit qu'on trouve 1 fois le mot-cl pour qu'on garde le fichier
      $flag=0;
      for ($i=0;$i<=$nb_keyword-1;$i++) {	# On prend chaque mot
        if ($result{"$fichier.$i"}) { $flag=1;}	# si 1 au moins est trouv dans le fichier, c'est bon
      }
    }
    if ($form{'boolean'} eq 'AND') {		# Il faut trouver chaque mot-cl au moins une fois pour qu'on garde le fichier
      $flag=1;
      for ($i=0;$i<=$nb_keyword-1;$i++) {	# On prend chaque mot
        if ($result{"$fichier.$i"}==0) { $flag*=0;}# si 1 au moins n'est pas trouv dans le fichier, c'est pas bon
      }
    }
    if ($flag) { push(@files2,$fichier);}	# hop, on slectionne le fichier !
    #print "fichier $fichier, mot $keyword[$i], on garde ? :<b>$flag</b><br>";
  }
  @files=@files2;
}
################################################
sub score {
local ($fichier)='';
local ($i)=0;
local ($buffer)='';

  foreach $fichier (@files) {			# Pour chaque fichier.
    for ($i=0;$i<=$nb_keyword-1;$i++) {	# On prend chaque mot
      # On affecte un point par mot-cl trouv dans le fichier.
      $score{$fichier}+=$result{"$fichier.$i"};

      # On affecte 4 points en plus par mot-cl trouv dans le titre de la page.
      $buffer=$titre{$fichier};
      if ($form{'case'} eq 'Insensitive') { 		# Si peu importe les majuscules/minuscules.
        while ($buffer=~ s/$keyword[$i]/ /i) {		# Chaque fois que l'on trouve le mot on le supprime, pour ne pas le compter 2 fois.
          $score{$fichier}+=4; 				# 4 points de plus
          #print "<b> 4 pts en plus !</b><br>\n";
        }
      }else {
        while ($buffer=~ s/$keyword[$i]/ /) {		# Idem, en tenant comptedes majuscules/minuscules
          $score{$fichier}+=4; 				# 4 points de plus
          #print "<b> 4 pts en plus !</b><br>\n";
        }
      }

      # On affecte 3 points en plus par mot-cl trouv dans la description de la page.
      $buffer=$description{$fichier};
      if ($form{'case'} eq 'Insensitive') { 		# Si peu importe les majuscules/minuscules.
        while ($buffer=~ s/$keyword[$i]/ /i) {		# Chaque fois que l'on trouve le mot on le supprime, pour ne pas le compter 2 fois.
          $score{$fichier}+=3; 				# 3 points de plus
          #print "<b> 3 pts en plus !</b><br>\n";
        }
      }else {
        while ($buffer=~ s/$keyword[$i]/ /) {		# Idem, en tenant comptedes majuscules/minuscules
          $score{$fichier}+=3; 				# 3 points de plus
          #print "<b> 3 pts en plus !</b><br>\n";
        }
      }

      # On affecte 2 points en plus par mot-cl trouv dans le META KEYWORDS de la page.
      $buffer=$metakeyword{$fichier};
      if ($form{'case'} eq 'Insensitive') { 		# Si peu importe les majuscules/minuscules.
        while ($buffer=~ s/$keyword[$i]/ /i) {		# Chaque fois que l'on trouve le mot on le supprime, pour ne pas le compter 2 fois.
          $score{$fichier}+=2; 				# 2 points de plus
          #print "<b> 2 pts en plus !</b><br>\n";
        }
      }else {
        while ($buffer=~ s/$keyword[$i]/ /) {		# Idem, en tenant comptedes majuscules/minuscules
          $score{$fichier}+=2; 				# 2 points de plus
          #print "<b> 2 pts en plus !</b><br>\n";
        }
      }
      
    }

    #print ("Fichier $fichier, SCORE : $score{$fichier} <br>\n");
  }

}
################################################
sub trier {
local ($i,$j);
local ($buffer);

  # Algorythme de tri ultra classique, cas d'cole :-). Nul besoin de l'optimiser en vitesse ici.
  for ($i=0;$i<=$nb_fichier-2;$i++) {
    for ($j=$i+1;$j<=$nb_fichier-1;$j++) {
     if ( $score{$files[$i]} < $score{$files[$j]} ) { # il faut inverser l'ordre
       $buffer=$files[$i];
       $files[$i]=$files[$j];
       $files[$j]=$buffer;
     }
    }
  }

  #for ($i=0;$i<=$nb_fichier-1;$i++) {
  #  print ("$i : Fichier $files[$i], SCORE : $score{$files[$i]} <br>\n");
  #}
}
################################################
sub header {

  print <<;
  <html>
  <head><title>LE FARFOUINEUR </title></head>
  <body bgcolor="#ffffff" text="#000000" link="#000099" vlink="#663366" alink="#ff0000">
  <h2 align="center">LE FARFOUINEUR </h1>

}
################################################
sub affiche_resultat {
local ($i)=0;
local ($fichier);
local ($res)=0;

  print <<;
    &nbsp; <br>
  <blockquote>
    <table border=0 cellpadding=0 cellspacing=0>
    <tr><td>
     <b><font face=arial size=-1><b>Le Farfouineur a trouv $nb_fichier pages web. </font></b>
    </td></tr> <tr><td bgcolor="#ffcc66" height="3">
    </td></tr>
    </table>
  </blockquote>


  print ("<blockquote>");
  print ("<font size=\"2\" face=\"Arial\">\n");
  for ($i=$form{'lastnb'}+1;$i<=$form{'lastnb'}+$form{'result_par_page'};$i++) {
    ## boucle principale d'affichage des rsultat
    if ($files[$i-1]) {
      # on ne gnre un affichage que si il y encore  afficher
      $fichier=$files[$i-1];
      print ("<dl><dt><b>$i.</b> <b><a href=\"$baseurl$fichier\">".$titre{$fichier}."</A></b><dd>\n");
      print ($description{$fichier}."<br>\n");
      print ("<b>URL :</b> <font color=gray>$baseurl$fichier<br>\n");
      print ("Dernire modification : ".$date{$fichier}." - Taille : ".$size{$fichier}."K. - Score de pertinence : ".$score{$fichier}.".");
      print ("</font></dl>\n");
    } else {				# plus rien  afficher
      if ($res==0) {$res=$i;}
      $fini=1;
    } # end if

  }  # end for
  print ("</font>\n");
  print ("</blockquote>");

  return $res;
}
################################################
################################################
sub formulaire {

  print <<;
  <form method="GET" action="$cgiurl">
    <div align="center"><center><table border="0" cellpadding="0" cellspacing="0" bgcolor="#FFCC66" width="500">
    <tr><td bgcolor="#003399" height="2" colspan="2" width="500"></td></tr>
    <tr>
      <td colspan="2" width="500"><strong>Tapez le texte que le Farfouineur doit chercher sur ce site : <br></strong>
      <input type="text" name="terms" value="$form{'terms'}" size="40">&nbsp; <input type="submit" value="Rechercher..."></td>
    </tr><tr>
      <td width="169"><font face="Arial" size="2"><strong>Rechercher :</strong></font></td>
      <td width="331"><font face="Arial" size="2"><select name="boolean" size="1">
        <option value="OR" selected>Au moins un des mots</option>
        <option value="AND">Tous les mots</option>
      </select></font></td>
    </tr><tr>
      <td width="169"><font face="Arial" size="2"><strong>Majuscules/minuscules :</strong></font></td>
      <td width="331"><font face="Arial" size="2"><select name="case" size="1">
        <option value="Insensitive" selected>Peu importe</option>
        <option value="Sensitive">Respecter</option>
      </select></font></td>
    </tr><tr>
      <td width="169"><font face="Arial" size="2"><strong>Afficher :</strong></font></td>
      <td width="331"><font face="Arial" size="2"><select name="result_par_page" size="1">
        <option selected value="5">5</option>
        <option value="10">10</option>
        <option value="25">25</option>
      </select> rsultats par page.</font></td>
    </tr><tr>
      <td colspan="2" width="500"><div align="center"><center><p>
       <font face="Arial" size="1"><em>(Ce Moteur de Recherche gratuit est disponible sur <a href="http://www.perl-gratuit.com">http://www.perl-gratuit.com</a> )</em></font>
      </td>
    </tr><tr>
      <td bgcolor="#003399" height="2" colspan="2" width="500"></td>
    </tr>
  </table>
  </center></div>
</form>


}
################################################
sub liens_suite {
local ($lastnb)=$form{'lastnb'}+$form{'result_par_page'};
local ($i,$nb_page)=(0,0);
local ($buffer,$texte,$rec,$suite)=('','','','');

  ## nb total de pages de rponses ##
  $nb_page=($nb_fichier/$form{'result_par_page'});
  if (int($nb_page)!=$nb_page) {
    $nb_page=int($nb_page)+1;
  }

  print ("<blockquote><FONT size=\"2\" face=\"Arial\"><b>Pages de rsultats : </b>");

  $nb_actuel=$lastnb/$form{'result_par_page'};		# no de page actuel
  #print "$nb_actuel <br>\n";

  ## Affichage page prcdente

  for ($i=1;$i<=$nb_page;$i++) {			# un lien pour chaque page
    $buffer=$ENV{QUERY_STRING};
    if ($form{'lastnb'}) {				# on est pas  la page 1
      $dummy=$form{'result_par_page'}*($i-1);
      $buffer=~ s/&lastnb\=$form{'lastnb'}/&lastnb\=$dummy/;
    }else {
      $buffer.='&lastnb='.($form{'result_par_page'}*($i-1));
    }
    if ($nb_actuel>1 and $i==$nb_actuel-1) { $prec="<a href=\"$cgiurl?$buffer\"><b>\[&lt;&lt;Prcdent\]</b></a>";}
    if ($nb_actuel!=$nb_page and $i==$nb_actuel+1) { $suite="<a href=\"$cgiurl?$buffer\"><b>\[Suivant&gt;&gt;\]</b></a>";}
    if ($nb_actuel==$i) {
      $texte.="<b>$i</b> &nbsp; ";			# pas de lien, pour la page actuelle
    }else {
      $texte.="<a href=\"$cgiurl?$buffer\">$i</a> &nbsp; ";
    }
  }
  print ("$prec &nbsp;$texte &nbsp;$suite </font></blockquote>");
}      
################################################
sub footer {

  print<<;
  <center>
  <hr width="80%" noshade>
  <font face="Arial" size="2">
  <a href="$baseurl">Homepage.</a> | <a href="$cgiurl?command=aide">Aide</a> | <a href="$cgiurl">Retour formulaire de recherche</a> <br>
  <font size="1"><b> Le Farfouineur v$version, script CGI Perl gratuit ralis par Sbastien Joncheray. <a href="http://www.perl-gratuit.com">http://www.perl-gratuit.com</a></b></font>
  </font>
  &nbsp; <br> &nbsp; <br>
  </center>

}
################################################
sub aide {

  print <<;
<html>
<head><title>LE FARFOUINEUR V$version - perl-gratuit.com</title></head>
<body bgcolor="#ffffff" text="#000000" link="#000099" vlink="#663366" alink="#ff0000">
<p align="center"><font size="6"><strong>LE FARFOUINEUR V$version<br>
</strong></font>-- Moteur de recherche de pages web, interne  un site --</p>
<p align="center"><font face="Arial" size="5" color="#000080"><strong><u>Aide - Trucs et
astuces</u></strong></font></p>
<hr width="80%" noshade>
<blockquote>
  <ul>
    <li><strong><font color="#004080">Aide&nbsp;  l'utilisation :<br>
      </font></strong>Dans la case de texte, tapez du texte ou des mots, spars par des
      espaces. Le Farfouineur vous renverra une liste de pages web, contenant les mots que vous
      recherchez.</li>
    <li><strong><font color="#004080">Classement et score des pages web.<br>
      </font></strong>La liste des pages web vous sont renvoys par ordre dcroissant de
      pertinence. Les premires pages sont donc celles qui semblent correspondre le mieux 
      votre recherche. Le score de chaque page est indiqu, sous sa description.<br>
      Le score est calcul de la faon suivante, pour chaque page : 1 point  chaque fois
      qu'un mot de recherche est rencontr dans la page, +4 points pour chaque mot prsent
      dans le titre (title) de la page, +3 points pour chaque mot prsent dans la description
      (meta name=&quot;description&quot;), +2 points pour chaque mot rencontr dans les
      keywords (meta name=&quot;keyword&quot; ou &quot;keywords&quot; ).<br>
      Puis les pages sont tris et affiches par ordre dcroissant du score.</li>
    <li><strong><font color="#004080">Majuscules/minusules :<br>
      </font></strong>Si vous slectionnez &quot;Peu importe&quot;, alors une recherche avec
      &quot;<strong>maison</strong>&quot;, donnera le mme rsultat qu'avec &quot;<strong>Maison</strong>&quot;.<br>
      Si vous slectionnez &quot;Respecter&quot;, les rsultats seront diffrents. Cela peut
      tre utile si vous recherchez une page faisant mention de Monsieur Maison, et non pas
      d'une maison </li>
    <li><strong><font color="#004080">Rechercher &quot;Tout les mots&quot; :</font></strong> Le
      Farfouineur n'affichera que les pages web contenant au moins une fois chacun des mots
      contenus dans le texte de recherche.<br>
      <strong><font color="#004080">Rechercher &quot;Au moins un des mots&quot; :</font></strong>
      Les rsultats sont plus larges ... Au moins, vous avez plus de chances d'obtenir des URLs
      .</li>
  </ul>
  <p align="center"><strong><u><font color="#0000A0" size="4">Trucs et astuces.</font></u></strong></p>
  <ul>
    <li>C'est bien un espace qu'il vous faut mettre entre chaque mots.<br>
    </li>
    <li>Ne mettez pas de mots inutiles du style <strong>de</strong> , <strong></strong> etc.
      (mettez <strong>vente maisons luxe Paris</strong>, plutt que <strong>vente de maisons de
      luxe  Paris</strong>, les rsultats seront meilleurs.)</li>
  </ul>
  <p>Vous allez tre du, le Farfouineur ne prend pas en compte les <strong>+
  &nbsp; :</strong> , comme le font d'autres moteurs de recherche comme notre ami
  AltaVista. Si nanmoins vous mettez de tels caractres dans la case de texte de
  recherche, le Farfouineur les ignore royalement, cela ne le drange point, et ne gnre
  pas d'erreur. <br>
  </p>
</blockquote>
  <hr width="80%" noshade>
  <p align="center"><strong><font size="2">Script CGI Perl ralis par Sbastien Joncheray,
  <a href="http://www.perl-gratuit.com">http://www.perl-gratuit.com</a>.</font></strong>
  </p>
  <center>
  <hr width="80%" noshade>
  <font face="Arial" size="2">
  <a href="$baseurl">Homepage.</a> | <a href="$cgiurl?command=aide">Aide</a> | <a href="$cgiurl">Retour formulaire de recherche</a> <br>
  </font>
  &nbsp; <br> &nbsp; <br>
  </center>
</body>
</html>


}
################################################
################################################
